﻿
using System.Collections.Generic;
using HeuristicLab.Problems.RoutePlanning.RoutingGraph;
namespace HeuristicLab.Problems.RoutePlanning.Interfaces {
  public interface IGraph {
    void AddVertex(Vertex vertex);
    Vertex GetVertex(long id);
    List<Vertex> GetVertices();
    void AddEdge(long startId, long endId);
    void AddEdge(Edge<Vertex> edge);
    void RemoveEdge(long startId, long endId);
    bool HasEdge(long startId, long endId);
    Edge<Vertex> GetEdge(long startId, long endId);
    List<Edge<Vertex>> GetEdges(long vertexId);
    List<Edge<Vertex>> GetInEdges(long vertexId);
    List<Edge<Vertex>> GetOutEdges(long vertexId);
    Dictionary<long, float> GetNeighborsWithWeight(long id);
    Dictionary<long, float> GetNeighborsWithWeightReversed(long id);
    int GetOutDegree(long id);
    int GetInDegree(long id);

    //float EstimatedCosts(long sourceId, long targetId);
  }
}
